unit Main;

interface

uses
  Windows, SysUtils, Classes, Forms, Dialogs, ShellAPI, ShlObj, Controls,
  StdCtrls;

type
  TMainForm = class(TForm)
    SaveDialog1: TSaveDialog;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    Button5: TButton;
    Button1: TButton;
    GroupBox2: TGroupBox;
    ListBox1: TListBox;
    Button2: TButton;
    Button3: TButton;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    GroupBox4: TGroupBox;
    Edit2: TEdit;
    Button4: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    SaveDialog2: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  public
    procedure deaktiviereelemente();
    procedure aktiviereelemente();
  private
    lg_StartFolder: String;
  end;

var
  MainForm: TMainForm;

implementation

{$R WindowsXP.res}

{$R *.dfm}

procedure TMainForm.deaktiviereelemente();
begin
  button1.Enabled := false;
  button2.Enabled := false;
  button3.Enabled := false;
  button4.Enabled := false;
  button5.Enabled := false;
  button6.Enabled := false;
  checkbox1.Enabled := false;
end;

procedure TMainForm.aktiviereelemente();
begin
  button1.Enabled := true;
  button2.Enabled := true;
  button3.Enabled := true;
  button4.Enabled := true;
  button5.Enabled := true;
  button6.Enabled := true;
  checkbox1.Enabled := true;
end;

///////////////////////////////////////////////////////////////////
// Call back function used to set the initial browse directory.
///////////////////////////////////////////////////////////////////
function BrowseForFolderCallBack(Wnd: HWND; uMsg: UINT;
        lParam, lpData: LPARAM): Integer stdcall;
begin
  if uMsg = BFFM_INITIALIZED then
    SendMessage(Wnd,BFFM_SETSELECTION,1,Integer(@mainform.lg_StartFolder[1]));
  result := 0;
end;

///////////////////////////////////////////////////////////////////
// This function allows the user to browse for a folder
//
// Arguments:-
//    browseTitle : The title to display on the browse dialog.
//  NewFolder : Allow to create a new folder
//  initialFolder : Optional argument. Use to specify the folder
//                  initially selected when the dialog opens.
//
// Returns: The empty string if no folder was selected (i.e. if the
//          user clicked cancel), otherwise the full folder path.
///////////////////////////////////////////////////////////////////
function BrowseForFolder(const browseTitle: String; const NewFolder: boolean = false;
        const initialFolder: String =''): String;
var
  browse_info: TBrowseInfo;
  folder: array[0..MAX_PATH] of char;
  find_context: PItemIDList;
const
  BIF_NEWDIALOGSTYLE=$40;
begin
  FillChar(browse_info,SizeOf(browse_info),#0);
  mainform.lg_StartFolder := initialFolder;
  browse_info.pszDisplayName := @folder[0];
  browse_info.lpszTitle := PChar(browseTitle);
  if NewFolder then
    browse_info.ulFlags := BIF_RETURNONLYFSDIRS or BIF_NEWDIALOGSTYLE
  else
    browse_info.ulFlags := BIF_RETURNONLYFSDIRS;
  browse_info.hwndOwner := Application.Handle;
  if initialFolder <> '' then
    browse_info.lpfn := BrowseForFolderCallBack;
  find_context := SHBrowseForFolder(browse_info);
  if Assigned(find_context) then
  begin
    if SHGetPathFromIDList(find_context,folder) then
      result := folder
    else
      result := '';
    GlobalFreePtr(find_context);
  end
  else
    result := '';
end;

function CheckImgFile(filename: string): boolean;
var
  f: TFileStream;
  Ch: Char;
  dateiok: boolean;
begin
  try
    dateiok := true;
    f := TFileStream.Create(filename,fmOpenRead);
    try
      if (lowercase(extractfileext(filename)) = '.jpg') or (lowercase(extractfileext(filename)) = '.jpeg') then
      begin
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($FF) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($D8) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($FF) then dateiok := false;
        f.Position := f.size - 2;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($FF) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($D9) then dateiok := false;
      end
      else if (lowercase(extractfileext(filename)) = '.gif') then
      begin
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($47) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($49) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($46) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($38) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if (ch <> chr($37)) and (ch <> chr($39)) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($61) then dateiok := false;
        f.Position := f.size - 2;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($00) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($3B) then dateiok := false;
      end
      else if (lowercase(extractfileext(filename)) = '.png') then
      begin
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($89) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($50) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($4E) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($47) then dateiok := false;
        f.Position := f.size - 2;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($60) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($82) then dateiok := false;
      end
      else if (lowercase(extractfileext(filename)) = '.bmp') then
      begin
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($42) then dateiok := false;
        f.Read(Ch,SizeOf(Ch));
        if ch <> chr($4D) then dateiok := false;
      end
      else
      begin
        dateiok := false;
      end;
    finally
      f.Free;
    end;
    result := dateiok;
  except
    result := false;
  end;
end;

procedure ScanDir(const Directory, Mask: String);
var
  SR: TSearchRec;
begin
  if FindFirst(Directory + Mask, faAnyFile - faDirectory, SR) = 0 then
  try
    repeat
      // Tritt z.B. bei Unicode-Dateinamen auf
      if fileexists(Directory + SR.Name) then
      begin
        if not CheckImgFile(Directory + SR.Name) then
        begin
          mainform.listbox1.items.add(Directory + SR.Name);
          application.processmessages;
        end;
      end;
    until FindNext(SR) <> 0;
  finally
    FindClose(SR);
  end;

  if mainform.checkbox1.checked then
  begin
    if FindFirst(Directory + '*.*', faAnyFile, SR) = 0 then
    try
      repeat
        // Tritt z.B. bei Unicode-Ordnernamen auf
        if directoryexists(Directory + SR.Name) then
        begin
          if ((SR.attr and faDirectory) = faDirectory) and
             (SR.Name <> '.') and (SR.Name <> '..') then
          begin
            ScanDir(IncludeTrailingPathDelimiter(Directory + SR.Name), Mask);
          end;
        end;
      until FindNext(SR) <> 0;
    finally
      FindClose(SR);
    end;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if Edit1.Text = '' then exit;
  deaktiviereelemente;
  Edit1.Text := IncludeTrailingPathDelimiter(Edit1.Text);
  listbox1.Clear;
  ScanDir(edit1.text, '*.jpg');
  ScanDir(edit1.text, '*.jpeg');
  ScanDir(edit1.text, '*.gif');
  ScanDir(edit1.text, '*.png');
  ScanDir(edit1.text, '*.bmp');
  aktiviereelemente;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  if listbox1.itemindex = -1 then exit;
  shellexecute(application.Handle, 'open', pchar(listbox1.Items.Strings[listbox1.itemindex]), '', '', SW_NORMAL);
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  if savedialog1.Execute then
  begin
    forcedirectories(extractfilepath(savedialog1.FileName));
    listbox1.Items.SaveToFile(savedialog1.FileName);
  end;
end;

procedure TMainForm.Button4Click(Sender: TObject);
var
  i: integer;
  n: string;
begin
  if Edit2.Text = '' then exit;
  deaktiviereelemente;
  Edit2.Text := IncludeTrailingPathDelimiter(Edit2.Text);
  for i := 0 to ListBox1.Count - 1 do
  begin
    n := copy(listbox1.Items.strings[i], length(edit1.text)+1, length(listbox1.Items.strings[i])-length(edit1.text));
    forcedirectories(extractfilepath(edit2.text+n));
    if movefile(pchar(listbox1.Items.strings[i]), pchar(edit2.text+n)) then
    begin
      listbox1.Items.Delete(listbox1.itemindex);
    end
    else
    begin
      Application.MessageBox(pchar('Datei konnte nicht verschoben werden:'+#13#10+listbox1.Items.Strings[i]), 'Fehler', MB_OK + MB_ICONHAND);
    end;
  end;
  aktiviereelemente;
end;

procedure TMainForm.Button5Click(Sender: TObject);
var
  fol: string;
begin
  fol := BrowseForFolder('Ordner auswhlen', false);
  if fol <> '' then edit1.Text := IncludeTrailingPathDelimiter(fol);
end;

procedure TMainForm.Button6Click(Sender: TObject);
var
  fol: string;
begin
  fol := BrowseForFolder('Ordner auswhlen', true);
  if fol <> '' then edit2.Text := IncludeTrailingPathDelimiter(fol);
end;

procedure TMainForm.Button7Click(Sender: TObject);
var
  ext: string;
begin
  if listbox1.itemindex = -1 then exit;
  ext := ExtractFileExt(listbox1.Items.Strings[listbox1.itemindex]);
  ext := copy(ext, 2, length(ext)-1);
  SaveDialog2.DefaultExt := '.'+ext;
  SaveDialog2.Filter := uppercase(ext)+'-Dateien (*.'+lowercase(ext)+')|*.'+ext+'|Alle Dateien (*.*)|*.*';
  if SaveDialog2.Execute then
  begin
    if renamefile(listbox1.Items.Strings[listbox1.itemindex], SaveDialog2.FileName) then
    begin
      Application.MessageBox('Datei erfolgreich verschoben', 'Besttigung', MB_OK + MB_ICONASTERISK);
      listbox1.Items.Delete(listbox1.itemindex);
    end
    else
    begin
      Application.MessageBox('Datei konnte nicht verschoben werden', 'Fehler', MB_OK + MB_ICONHAND);
    end;
  end;
end;

procedure TMainForm.Button8Click(Sender: TObject);
begin
  if listbox1.itemindex = -1 then exit;
  if (Application.MessageBox('Datei wirklich lschen?', 'Sicherheitsabfrage',
      MB_YESNOCANCEL + MB_ICONQUESTION) = ID_YES) then
  begin
    if deletefile(listbox1.Items.Strings[listbox1.itemindex]) then
    begin
      Application.MessageBox('Datei erfolgreich gelscht', 'Besttigung', MB_OK + MB_ICONASTERISK);
      listbox1.Items.Delete(listbox1.itemindex);
    end
    else
    begin
      Application.MessageBox('Datei konnte nicht gelscht werden', 'Fehler', MB_OK + MB_ICONHAND);
    end;
  end;
end;

end.
